# Calendrier de l'avent des syscall

Du 1er au 24 décembre, on découvre des syscalls. Vous pouvez trouver tous les
défis sur [le site de l'Operating System Group](https://osg.tuhh.de/Advent/).

Il suffit d'aller dans un dossier et faire `make` pour avoir un exécutable.

Des fichiers pré-faits sont fournis. J'ai cependant décidé d'essayer de m'en
passer et de tout faire depuis 0. Parfois, je m'en inspire pour avoir un début
de code.

## Plus d'informations sur les jours

### 01 - cat

Syscalls utilisés: open, read, write, close.

Il s'agit d'un cat. Il prend en paramètres N fichiers et les affiche.

### 02 - fork

Syscalls utilisés: clone.

On fait un fork basique, avec d'autres épreuves tel qu'une chimère
processus-thread, un thread et un processus qui change d'utilisateur.

Je n'ai pas fait la denière étape où il faut changer l'UID.

### 03 - Zone mémoire

Syscalls utilisés: ftruncate, mmap, open, close.

Liaison d'un fichier et d'une zone mémoire. Chaque fois qu'on lance le
programme, un compteur est incrémenté de 1. Je me suis aidé du template pour la
création des variables de base.
